using System;
using System.Collections;

namespace BusinessLogic
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class PurchaseOrder
	{
		NsPersistent.PPurchaseOrder mPersistent = null;

		public PurchaseOrder(int iCustomerId, DateTime orderDate)
		{
			mPersistent = new NsPersistent.PPurchaseOrder(iCustomerId, orderDate);
		}

		public PurchaseOrder(NsPersistent.PPurchaseOrder persistent)
		{
			mPersistent = persistent;
		}

		public Decimal GetTotalPrice()
		{
			NsPersistent.POrderItem [] aPersistents = mPersistent.GetOrderedProducts();
			Decimal dcTotal = 0;

			foreach (NsPersistent.POrderItem orderedProduct in aPersistents)
			{
				dcTotal += orderedProduct.Qty * orderedProduct.GetProduct().Price;
			}

			return dcTotal;
		}

		public string GetDeliveryReport()
		{
			OrderDeliveryReport report = new OrderDeliveryReport();
			System.Xml.XmlNode orderNode = report.AddOrderElement(mPersistent.OrderId, mPersistent.OrderDate);

			NsPersistent.POrderItem [] aOrderedProducts = mPersistent.GetOrderedProducts();
			System.Xml.XmlNode productNode = null;
			NsPersistent.PProduct product = null;

			foreach (NsPersistent.POrderItem orderedProduct in aOrderedProducts)
			{
				productNode = report.AddProductElement(orderNode, orderedProduct.GetProduct().ProductId, 
					orderedProduct.GetProduct().Description, orderedProduct.Qty);

			}
		}
	}
}
