using System;

namespace NsPersistent
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class POrder
	{
		protected DataAccessService.DS.OrderRow mDataRow = null;

		internal POrder(DataAccessService.DS.OrderRow dataRow)
		{
			mDataRow = dataRow;
		}

		public POrder(int iCustomerId, DateTime orderDate)
		{
			mDataRow = DataSetManager.DS.Order.NewOrderRow();
			mDataRow.CustomerId = iCustomerId;
			mDataRow.OrderDate = orderDate;
			mDataRow.Closed = false;
			DataSetManager.DS.Order.AddOrderRow(mDataRow);
		}

		public void Delete()
		{
			mDataRow.Table.Rows.Remove(mDataRow);
			mDataRow = null;
		}

		public PCustomer GetCustomer()
		{
			return new PCustomer(mDataRow.CustomerRow);
		}

		public POrderItem AddOrderItem(int iProductId, int iQty, int iMinDeliveryQty)
		{
			NsPersistent.DataAccessService.DS.OrderItemRow row = DataSetManager.DS.OrderItem.NewOrderItemRow();
			row.OrderId = mDataRow.OrderId;
			row.ProductId = iProductId;
			row.Qty = iQty;
			row.MinDeliveryQty = iMinDeliveryQty;
			row.PendingQty = iQty;
			DataSetManager.DS.OrderItem.AddOrderItemRow(row);
			return new POrderItem(row);
		}

		public POrderItem [] GetOrderItems()
		{
			DataAccessService.DS.OrderItemRow [] aRows = mDataRow.GetOrderItemRows();
			POrderItem [] aPersistents = new POrderItem[aRows.Length];
			
			for (int i = 0; i < aRows.Length; i++)
			{
				aPersistents[i] = new POrderItem(aRows[i]);
			}

			return aPersistents;
		}

		public PDelivery MakeDelivery(DateTime deliveryDate, string strAddress)
		{
			DataAccessService.DS.DeliveryRow row = DataSetManager.DS.Delivery.NewDeliveryRow();
			row.OrderId = mDataRow.OrderId;
			row.DeliveryDate = deliveryDate;
			row.Address = strAddress;
			DataSetManager.DS.Delivery.AddDeliveryRow(row);
			return new PDelivery(row);
		}

		public PDelivery [] GetDeliveries()
		{
			DataAccessService.DS.DeliveryRow [] aRows = mDataRow.GetDeliveryRows();
			PDelivery [] aPersistents = new PDelivery[aRows.Length];

			for (int i = 0; i < aRows.Length; i++)
			{
				aPersistents[i] = new PDelivery(aRows[i]);
			}

			return aPersistents;
		}

		public int OrderId
		{
			get { return mDataRow.OrderId; }
		}

		public int CustomerId
		{
			get { return mDataRow.CustomerId; }
		}

		public DateTime OrderDate
		{
			get { return mDataRow.OrderDate; }
		}

		public Decimal TotalCharge
		{
			get { return mDataRow.TotalCharge; }
			set { mDataRow.TotalCharge = value; }
		}

		public bool Closed
		{
			get { return mDataRow.Closed; }
			set { mDataRow.Closed = value; }
		}
	}
}
