using System;

namespace NsPersistent
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class POrderedProduct
	{
		protected DataAccessService.DS.OrderedProductRow mDataRow = null;

		internal POrderedProduct(DataAccessService.DS.OrderedProductRow dataRow)
		{
			mDataRow = dataRow;
		}

		public POrderedProduct(int iOrderId, int iProductId, int iQty, int iMinDeliveryQty)
		{
			mDataRow = DataSetManager.DS.OrderedProduct.NewOrderedProductRow();
			mDataRow.OrderId = iOrderId;
			mDataRow.ProductId = iProductId;
			mDataRow.Qty = iQty;
			mDataRow.MinDeliveryQty = iMinDeliveryQty;
			DataSetManager.DS.OrderedProduct.AddOrderedProductRow(mDataRow);
		}

		public void Delete()
		{
			mDataRow.Table.Rows.Remove(mDataRow);
			mDataRow = null;
		}

		public PProduct GetProduct()
		{
			return new PProduct(mDataRow.ProductRow);
		}

		public int Qty
		{
			get { return mDataRow.Qty; }
			set { mDataRow.Qty = value; }
		}

		public int MinimumDeliveryQty
		{
			get { return mDataRow.MinDeliveryQty; }
			set { mDataRow.MinDeliveryQty = value; }
		}

		public int PendingQty
		{
			get { return mDataRow.PendingQty; }
			set { mDataRow.PendingQty = value; }
		}

		public Decimal SubTotal
		{
			get { return mDataRow.SubTotal; }
			set { mDataRow.SubTotal = value; }
		}
	}
}
