using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

namespace NsDataAccess
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class DataAccess : System.Web.Services.WebService
	{
		public DataAccess()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		// Get the Communicator stored in Application. If no Communicator has ever been created, create one from 
		// the settings in the configuration file, and store it in Application.
		private Communicator GetCommunicator()
		{
			Communicator communicator = null;

			// If this web service is first-time invoked and no WksCommunicator instance has been created yet ...
			if (Application["Communicator"] == null) 
			{
				// Find the connection string for the database in the configuration file
				string strConnectionString = System.Configuration.ConfigurationSettings.AppSettings["DBConnectionString"];
				System.Data.OleDb.OleDbConnection cn = new System.Data.OleDb.OleDbConnection(strConnectionString);

				// Find the type of the Communicator in the configuration file
				string strCommunicatorClass = System.Configuration.ConfigurationSettings.AppSettings["Communicator"];
				Type CommunicatorClass = Type.GetType(strCommunicatorClass);

				// Get its constructor and invoke it to get a Communicator instance
				Type[] types = new Type[1];
				types[0] = typeof(System.Data.OleDb.OleDbConnection);
				System.Reflection.ConstructorInfo constructorInfo = CommunicatorClass.GetConstructor(types);
				object[] args = new object[1];
				args[0] = cn;
				communicator = (Communicator)constructorInfo.Invoke(args);

				// Store the created WksCommunicator instance in Session
				Application["Communicator"] = communicator;
			}
			else // If a WksCommunicator instance has been stored ...
				communicator = (Communicator)Application ["Communicator"];

			return communicator;
		}

		[WebMethod]
		public DS GetDataSet()
		{
			Communicator communicator = GetCommunicator();
			return communicator.GetDataSet();
		}

		[WebMethod]
		public void Update(DS ds)
		{
			Communicator communicator = GetCommunicator();
			communicator.Update(ds);
		}
	}
}
